        .486
        .model flat,stdcall



	PUBLIC	DisplayRegisters, ModifyRegisters, ReadReg
        PUBLIC  Dregs,Aregs,SR, PC, USP, MSP, ISP, VBR, DregTop
        extrn WriteString : PROC ,WriteChar : PROC, PrintDword : PROC
        extrn   WadeSpace : PROC, ReadNumber : PROC, PrintSpace : PROC
        extrn   dbg_disline : PROC, GetInputLine : PROC, crlf : PROC
        extrn   dbg_buffer : byte , membase : dword, disindex : dword
        extrn   PrintWord : PROC, left : dword

        .data
Dregs   dd      8 DUP (0)
Aregs   dd      8 DUP (0)
sfc     dd      0
dfc     dd      0
CACR    dd      0
USP     dd      0
VBR     dd      0
CAAR    dd      0
MSP     dd      0
ISP     dd      0
PC     dd      0
SR      dd      0
DregTop label   dword
prompt  db      13,10,": ",0
prompt2 db      "- ",0
USPprompt db    "USP:",0
SRprompt db     "SR:",0
	.code
flm	label byte
        db      28
        dd      "NXX "
        db      27
        dd      "PLMI"
        db      26
	dd	"NZZR"
        db      25
	dd	"NVOV"
        db      24
	dd	"NCCY"
	db	-1
	db	0
;
FindRegister	PROC
        mov     cl,0
        cmp     al,'a'
        jnz     notaddr
        or      cl,8
notaddr:
        cmp     al,'d'
        jnz     done
        inc     esi
        lodsb
        cmp     al,'0'
        jc      done
        cmp     al,'9'
        ja      done
        sub     al,'0'
        or      al,cl
        movzx   edi,al
        shl     edi,2
        mov     cl,4
        mov     al,[esi]
        cmp     al,'.'
        jnz     nosize
        lodsw
        xchg    al,ah
        cmp     al,'l'
        jz      nosize
        mov     cl,2
        cmp     al,'w'
        jz      nosize
        dec     cl
nosize:
        sub     al,al
done:
        ret
FindRegister	ENDP
;
; read the value of a reg (used by input routines)
; INPUT: SI points at the input line 
; OUTPUT:If we found a byte or word register, EAX holds the zero-extended
;	value that was in the corresponding bucket.
;	If we found a dword register, EAX holds the dword value
;	NZ if register not found by name, but still might be a number
;		Else, NC if segment reg, CY if non-segment reg found
;	SI moved past a register found by name, else not moved
;
ReadReg		PROC
	push	ecx			;ECX holds ???
	call	FindRegister		;see if we found a non-segment reg
	jnz	notreg			;if not, jmp
        mov     eax,[edi+Dregs]
        bswap   eax
        cmp     cl,4
        jz      okx
        cmp     cl,2
        jnz     dobyte
        movzx   eax,ax
        jmp     okx
dobyte:
        movzx   eax,al
okx:
        clc
        pop     ecx
        ret
notreg:
        stc
	pop	ecx			;and ECX
	ret
ReadReg	ENDP
;
; Read value for a register back into memory (R) command
;
ReadRegValue	PROC
        call    WadeSpace
	jz	doregprompt
        inc     esi
	cmp	al,':'
	jz	ReadRegValue
	cmp	al,'='
	jz	ReadRegValue
        dec     esi
	call	ReadNumber
	ret
doregprompt:
        push    ebx                      ; Else put up prompt
        push    ecx                      ;
        mov     edi,offset prompt
        call    WriteString
	call	GetInputLine		; Get input line
        pop     ecx                      ;
        pop     ebx                      ;
        call    WadeSpace               ; Ignore spaces
	jz	short rr_out		; Quit if so
	call	ReadNumber
	ret
rr_out:
	stc
	ret
ReadRegValue	ENDP	
;
; DisplayFlags command
;
EditFlags PROC
        sub     edx,edx
        inc     esi                      ; past the 'f'
        call    WadeSpace
        jnz     readflags
        call    crlf
        call    putflags
        mov     edi,offset prompt2
        call    WriteString
	call	GetInputLine		; Get input line
        mov     edx,1
readflags:
        call    WadeSpace
        jz      efx
        cmp     al,','
        jz      efskipcomma
        mov     ax,[esi]
        xchg    al,ah
        and     ax,0DFDFh               ; make upper case
        cmp     al,' '
        ja      notal
        mov     al,' '
notal:
        cmp     ah,' '
        ja      notah
        mov     ah,' '
notah:
        mov     bx,ax
        push    esi
        mov     esi,offset flm
efl:
        lodsb
        test    al,al
        jns     efc
        pop     esi
        add     esi,2    ; bump for no prompt mode
        test    edx,1
        jz      efnoadd
        add     si,15   ; remainder of bump for prompt mode
efnoadd:
        stc
        ret
efc:
        movzx   ecx,al
        lodsd
        cmp     ax,bx
        jnz     nosetmatch
        bts     [SR],ecx
        jmp     short effin
nosetmatch:
        shr     eax,16
        cmp     ax,bx
        jnz     efl
        btr     [SR],ecx
effin:
        pop     esi
        inc     esi
efskipcomma:
        inc     esi
        jmp     readflags

efx:
        clc
        ret
        
EditFlags ENDP
;
; main 'Reg' command
;
ModifyRegisters	PROC	
        call    WadeSpace               ; Wade through spaces
	jz	DisplayRegisters	; Display regs
contmod3:
        cmp     al,'f'
        jz      EditFlags
	call	FindRegister
	jnz	badreg
        push    edi
        push    ecx
	call	ReadRegValue
        pop     ecx
        pop     edi
	jc	badreg2
        cmp     cl,4
        jnz     chkword
        bswap   eax
        mov     [edi+Dregs],eax
	clc
	ret
chkword:
        cmp     cl,2
        jnz     dobyte2
        xchg    al,ah
        mov     word ptr [edi + Dregs + 2],ax
        clc
        ret
dobyte2:
        mov     byte ptr [edi + Dregs + 3],al
        clc
        ret
badreg2:
	clc
	ret
badreg:
	stc
	ret
bytereg:
	mov	[di],al
	ret
ModifyRegisters ENDP
putflags PROC
        mov     esi,offset flm
putflags2:
        lods    byte ptr [esi]
	or	al,al
	js	pfdone
        movzx   eax,al
        bt      dword ptr [SR],eax
        lods    dword ptr [esi]
	jc	isclr
        shr     eax,16
isclr:
        xchg    ah,al
        call    WriteChar
        xchg    al,ah
        call    WriteChar
	call	PrintSpace
	jmp	putflags2
pfdone:
	ret
putflags ENDP
DisplayReg PROC
        push    edi
        push    ecx
        btr     cx,3
        mov     al,'d'
        jnc     isd
        mov     al,'a'
isd:
        call    WriteChar
        mov     al,cl
        add     al,'0'
        call    WriteChar
        mov     al,':'
        call    WriteChar
        pop     ecx
        mov     eax,[ecx*4 + Dregs]
        bswap   eax
        call    PrintDword
        call    PrintSpace
        pop     edi
        ret
DisplayReg ENDP
;
; Display the processor regs
;
DisplayRegisters	PROC	
        sub     ecx,ecx
DisplayRegistersLoop:
        test    ecx,3
        jnz     nolf
        call    crlf
nolf:
        call    DisplayReg
        inc     ecx
        cmp     ecx,16
        jb      DisplayRegistersLoop
        call    PrintSpace
        call    crlf
        mov     edi,offset USPprompt
        call    WriteString
        mov     eax,[USP]
        bswap   eax
        call    PrintDword
        call    PrintSpace
        call    PrintSpace
        mov     edi,offset SRprompt
        call    WriteString
        mov     eax,[SR]
        bswap   eax
        call    PrintWord
        call    PrintSpace
        call    PrintSpace
        call    PrintSpace
        call    putflags
        call    crlf
        mov     esi,[PC]
        mov     [disindex],esi
        add     esi,[membase]
        call    dbg_disline
        mov     [left],0
        mov     edi,offset dbg_buffer
        call    WriteString
        
        clc
	ret
DisplayRegisters	ENDP	
END