        .486
        .model flat, stdcall
include win32.asi
include win32.ase
        public  ResetProcessor
        extrn Dregs : dword, hasvects : byte, prm_00 : byte
        extrn SR: dword , PC :dword, xxfil : byte, finish : PROC
        extrn membase :dword, filesize : dword,WriteString : PROC
        extrn DisplayRegisters : PROC, emureset : PROC, oldsr : word
        extrn ISP : DWORD
        .data
readlen dd      0
ResErrMsg       db      "Could not reload file, exiting",0

        .code

ResetProcessor PROC
        mov     edi,offset Dregs
        mov     ecx,26
        sub     eax,eax
        rep     stosd
        mov     [SR],00270000h ; must be interrupt stack
        mov     ax,word ptr [SR+2]
        mov     [oldsr],ax  
        test    [hasvects],1
        jz      not_vects
        mov     eax,[membase]
        mov     ecx,[eax]
        mov     [Dregs + 15 * 4],ecx
        mov     [ISP],ecx
        mov     ecx,[eax+4]
        bswap   ecx
        mov     [PC],ecx
not_vects:
        call    CreateFile, offset xxfil,GENERIC_READ,0,0,OPEN_EXISTING,0,0
        cmp     eax,INVALID_HANDLE_VALUE
        jz      reseterr
        push    eax
        call    ReadFile, eax,[membase],[filesize],offset readlen,0
        pop     eax
        call    CloseHandle, eax
        call    emureset
        call    DisplayRegisters
        clc
        ret
reseterr:
        mov     edi,offset ResErrMsg
        call    WriteString
        jmp     finish        
ResetProcessor ENDP

        end