        .386
        .model  flat,stdcall

include WIN32.asi
include win32.ase

        publicdll  EmuLoad, EmuStore, EmuParms, EmuReset
        public  hInst
        extrn CreateConsole : PROC, DestroyConsole : PROC, TypeChar : PROC
        extrn GetKey : PROC, ConsoleReset : PROC

        .data
initted dd      0
hInst   dd      0
membase dd      0
memtop  dd      0
isrCallBack dd  0

emuparms label dword
        dd      0       ; min size
        dd      0ffffff00h ; emubytes low
        dd      0ffffffffh ;emubytes high

        .code
start   PROC    hInstance : DWORD, reason : DWORD, nullptr : DWORD
        cmp     [reason],DLL_PROCESS_ATTACH
        jnz     notinit
        inc     [initted]       
        cmp     [initted],1
        jnz     sex
        mov     eax,[hInstance]
        mov     [hInst],eax
        call    CreateConsole
        jmp     sex
notinit:
        cmp     [reason],DLL_PROCESS_DETACH
        jnz     sex
        dec     [initted]
        jnz     sex
        call    DestroyConsole
sex:
        mov     eax,1
        ret
start   ENDP

EmuParms PROC   base : DWORD, endmem : DWORD,  ISRCallBack : DWORD
        mov     eax,[isrCallBack]
        mov     [isrCallBack],eax
        mov     eax,[base]
        add     [emuparms+4],eax
        add     [emuparms+8],eax
        mov     [membase],eax
        mov     eax,[endmem]
        mov     [memtop],eax
        mov     eax,offset emuparms
        ret
EmuParms ENDP
EmuLoad PROC    address : DWORD, size : DWORD
        call    GetKey
        ret
EmuLoad Endp

EmuStore PROC   address : DWORD , value : DWORD, size : DWORD
        mov     eax,[value]
        call    TypeChar
        ret
EmuStore Endp
EmuReset PROC
        call    ConsoleReset
        ret
EmuReset ENDP
        end start