        .486
        .model flat,stdcall
include opcode.inc
include operand.inc

        public    dbg_cd_dispatch,dbg_sz_dispatch,dbg_op_dispatch
        public    dbg_op1,dbg_op2,dbg_op3, dbg_badflag
        extrn    mn_chkz:byte,mn_cmpz:byte,mn_z2:byte,dbg_buffer:byte,dbg_movsalt:byte
        extrn    mn_zu:byte,mn_zs:byte,dbg_strapp:proc
        extrn    mn_zl:byte,firstword:dword, oldpc : dword
        extrn    membase :dword, thesize : byte

        .data
dbg_op1     operand       <?>
dbg_op2     operand       <?>
dbg_op3     operand       <?>
dbg_badflag db   0


        .code
based proc
        lodsw
        xchg    al,ah
        mov     ecx,eax
        mov     edx,eax
        shr     ecx,12
        mov     [edi+operand.r2],cl
        mov     ecx,eax
        shr     eax,7
        and     eax,BASE8
        shr     ecx,11
        and     ecx,1
        inc     ecx
        or      eax,ecx
        mov     [edi+operand.mods],ax
        bt      edx,8
        jc      longbase
        movsx   eax,dl
        add     [edi+operand.bd],eax
        mov     eax,BASED
        ret
longbase:
        bt      edx,3
        jc      badmisc
        bt      edx,7
        jnc     nobasesuppress
        or      [edi+operand.mods],BASESUPPRESS
        mov     [edi+operand.bd],0
nobasesuppress:
        bt      edx,6
        jnc     noindexsuppress
        or      [edi+operand.mods],INDEXSUPPRESS
noindexsuppress:
        mov     eax,edx
        shr     eax,4
        and     eax,3
        je      badmisc
        mov     ecx,eax
        shl     ecx,4
        or      [edi+ operand.mods],cx
        dec     eax
        je      nobase
        bt      eax,1
        jc     longbase2
        lodsw
        movsx     ax,ah
        jmp     baseconverge
longbase2:
        lodsd
        bswap   eax
baseconverge:
        add     [edi + operand.bd],eax        
nobase:
        mov     [edi + operand.od],0
        and     edx,7
        mov     eax,edx
        and     eax,3
        je      noindir
        mov     ecx,eax
        shl     ecx,6
        or      [edi+operand.mods],cx
        dec     eax
        je      noodisp
        bt      eax,1
        jc      longodisp
        lodsw
        movsx   eax,ah
        jmp     odconverge   
longodisp:
        lodsd
        bswap   eax
odconverge:     
        mov     [edi +operand.od],eax
noodisp:
        bt      edx,2
        jnc     preindex
        or      [edi + operand.mods],POSTINDEX
preindex:
        mov     eax,MEM
        ret
noindir:
        mov     eax,BASED
        ret
based endp
fmabsw proc
        sub     eax,eax
        lodsw   
        xchg    al,ah
        mov     [edi+operand.bd],eax
        mov     [edi+operand.mods],BDWORD
        mov     eax,ABSW
        ret
fmabsw endp
fmabsl proc
        lodsd
        bswap   eax
        mov     [edi+operand.bd],eax
        mov     [edi+operand.mods],BDLONG
        mov     eax,ABSL
        ret
fmabsl endp
fmpcindir proc
        mov     eax,esi
        sub     eax,[membase]
        mov     [edi +operand.bd],eax
        lodsw
        xchg    al,ah
        movsx   eax,ax
        add     [edi + operand.bd],eax
        mov     [edi+operand.mods],BDLONG
        mov     eax,PCINDEX
        ret
fmpcindir ENDP
fmpcbased PROC
        mov     eax,esi
        sub     eax,[membase]
        mov     [edi +operand.bd],eax
        call    based
        cmp     eax,BASED
        jz      pcbased
        mov     eax,PCMEM
        ret
pcbased:
        mov     eax,PCBASED
        ret
fmpcbased ENDP
fmimm PROC
        cmp     [thesize],SZ_WORD
        je      immword
        ja      immlong
        lodsw
        movzx   eax,ah
        mov     [edi + operand.bd],eax
        mov     [edi + operand.mods],BDBYTE
        mov     eax,IMM
        ret
immlong:
        lodsd
        bswap   eax
        mov     [edi + operand.bd],eax
        mov     [edi + operand.mods],BDLONG
        mov     eax,IMM
        ret
immword:
        lodsw
        xchg    al,ah
        movzx   eax,ax
        mov     [edi + operand.bd],eax
        mov     [edi + operand.mods],BDWORD
        mov     eax,IMM
        ret
fmimm ENDP
fmtab   dd      fmabsw,fmabsl,fmpcindir,fmpcbased,fmimm

fillan PROC
        bts     ecx,3
filldn:
        mov     eax,REGN
fillreg:
        mov     [edi + operand.r1],cl
        ret
fillan ENDP
fillanindir proc
        bts     ecx,3
        mov     eax,AINDR
        jmp     fillreg
fillanindir ENDP
fillanpost proc
        bts     ecx,3
        mov     eax,APOSTINC
        jmp     fillreg
fillanpost ENDP
fillanpre PROC
        bts     ecx,3
        mov     eax,APREDEC
        jmp     fillreg
fillanpre ENDP
fillandisp PROC
        lodsw
        xchg    al,ah
        movsx   eax,ax
        mov     [edi + operand.bd],eax
        mov     [edi + operand.mods],BDWORD
        bts     ecx,3
        mov     eax,AINDEX
        jmp     fillreg
fillandisp ENDP
fillanbased PROC
        call    fillan
        jmp     based
fillanbased ENDP
fillmisc PROC
        movsx   ecx,cl
        cmp     ecx,5
        jnc     badmisc
        mov     eax,[fmtab + ecx*4]
        jmp     eax
badmisc:
        inc     dbg_badflag
        mov     eax,NONE
        ret
fillmisc ENDP
        
filltab label dword
        dd    filldn,fillan,fillanindir
        dd    fillanpost,fillanpre,fillandisp
        dd    fillanbased,fillmisc

fillea PROC
        mov     ecx,[firstword]
fillea1:
        mov     edx,ecx
        and     edx,03fh
        shr     edx,3
        mov     edx,[filltab + edx * 4]
        and     ecx,7
        call    edx
op_none:
        ret
fillea ENDP
op_ea proc
        sub     ecx,ecx
        jmp     fillea
op_ea ENDP
op_eaa PROC
        mov     ecx,ODNOA
        jmp     fillea
op_eaa ENDP
op_eaadnop PROC
        jmp     fillea
op_eaadnop ENDP
op_eaadnor PROC
        mov     ecx,ODNOA + ODNOD + ODNON + ODNOO + ODNOR
        jmp     fillea
op_eaadnor ENDP
op_eaadnp PROC
        mov     ecx,ODNOA + ODNOD + ODNON + ODNOP
        jmp     fillea
op_eaadnp ENDP
op_eaadnr PROC
        mov     ecx,ODNOA + ODNOD + ODNON + ODNOR
        jmp     fillea
op_eaadnr ENDP
op_eaanor PROC
        mov     ecx,ODNOA + ODNON + ODNOO + ODNOR
        jmp     fillea
op_eaanor ENDP
op_eaanorp PROC
        mov     ecx,ODNOA + ODNON + ODNOO + ODNOR + ODNOP
        jmp     fillea
op_eaanorp ENDP
op_eaanp PROC
        mov     ecx,ODNOA + ODNON + ODNOP
        jmp     fillea
op_eaanp ENDP
op_eaan PROC
        mov     ecx,ODNOA + ODNON
        jmp     fillea
op_eaan ENDP
op_eadnp PROC
        mov     ecx,ODNOD + ODNON + ODNOP
        jmp     fillea
op_eadnp ENDP
op_eadnop PROC
        mov     ecx,ODNOD + ODNON + ODNOO + ODNOP
        jmp     fillea
op_eadnop ENDP
op_eanp PROC
        mov     ecx,ODNOA + ODNON + ODNOP
        jmp     fillea
op_eanp ENDP
op_mea PROC
        mov     edx,[firstword]
        shr     edx,6
        mov     ecx,edx
        shr     ecx,3
        and     ecx,7
        and     edx,7
        shl     edx,3
        or      ecx,edx
        jmp     fillea1
op_mea ENDP
op_mpareg PROC
        mov     ecx,[firstword]
        and     ecx,7
        jmp     fillandisp
op_mpareg ENDP
op_areg9b PROC
        mov     ecx,[firstword]
        shr     ecx,9
        and     ecx,7
        jmp     fillan
op_areg9b ENDP
op_dreg9b PROC
        mov     ecx,[firstword]
        shr     ecx,9
        and     ecx,7
        jmp     filldn
op_dreg9b ENDP
op_dreg02 PROC
        mov     ecx,[firstword]
        and     ecx,7
        jmp     filldn
op_dreg02 ENDP
op_areg02 PROC
        mov     ecx,[firstword]
        and     ecx,7
        jmp     fillan
op_areg02 ENDP
op_imm07 PROC
        movsx     ecx,byte ptr [firstword]
        or      [edi + operand.mods],BDLONG
        mov     [edi + operand.bd],ecx
        mov     eax,IMM
        ret
op_imm07 ENDP
op_imm03 PROC
        movzx   ecx,byte ptr [firstword]
        and     ecx,15
        mov     [edi + operand.bd],ecx
        mov     eax,IMM
        ret
op_imm03 ENDP
op_imm02 PROC
        movzx   ecx,byte ptr [firstword]
        and     ecx,7
        mov     [edi + operand.bd],ecx
        mov     eax,IMM
        ret
op_imm02 ENDP
op_immb PROC
        lodsw
        xchg    al,ah
        movzx   eax,al
        mov     [edi+operand.bd],eax
        mov     eax,IMM
        ret
op_immb ENDP
op_immw PROC
        lodsw
        xchg    al,ah
        movzx   eax,ax
        mov     [edi+operand.bd],eax
        mov     [edi+operand.mods],BDWORD
        mov     eax,IMM
        ret
op_immw ENDP
op_imm  PROC
        jmp     fmimm
op_imm  ENDP
op_rn04 PROC
        mov     ecx,[firstword]
        and     ecx,15
        jmp     filldn
op_rn04 ENDP
op_c2a PROC
        mov     ecx,[oldpc]
        mov     al,[ecx + 3]
        and     al,7
        mov     [edi + operand.r1],al
        mov     al,[ecx + 5]
        and     al,7
        mov     [edi + operand.r2],al
        mov     eax,CAS2REG
        ret
op_c2a ENDP
        ret
op_c2b PROC
        mov     ecx,[oldpc]
        mov     ax,[ecx + 2]
        xchg    al,ah
        shr     ax,6
        and     al,7
        mov     [edi + operand.r1],al
        mov     ax,[ecx + 4]
        xchg    al,ah
        shr     ax,6
        and     al,7
        mov     [edi + operand.r2],al
        mov     eax,CAS2REG
        ret
op_c2b ENDP
op_c2c PROC
        mov     ecx,[oldpc]
        mov     al,[ecx + 3]
        shr     al,4
        and     al,15
        mov     [edi + operand.r1],al
        mov     al,[ecx + 5]
        shr     al,4
        and     al,15
        mov     [edi + operand.r2],al
        mov     eax,CAS2REG2
        ret
op_c2c ENDP
op_ereg1 PROC
        mov     ecx,[oldpc]
        mov     cx,[ecx+3]
        and     cl,7
        jmp     filldn
op_ereg1 ENDP
op_ereg2 PROC
        mov     ecx,[oldpc]
        mov     cx,[ecx+2]
        xchg    cl,ch
        shr     cx,6
        and     cl,7
        jmp     filldn
op_ereg2 ENDP
op_bfdreg PROC
op_movecreg:
op_ern:
        mov     ecx,[oldpc]
        mov     cl,[ecx+2]
        shr     cl,4
        jmp     filldn
op_bfdreg ENDP
op_ccr PROC
        mov     [edi + operand.r1],RG_CCR
        mov     eax,REGN
        ret
op_ccr ENDP
op_sr PROC
        mov     [edi + operand.r1],RG_SR
        mov     eax,REGN
        ret
op_sr ENDP
op_usp PROC
        mov     [edi + operand.r1],RG_USP
        mov     eax,REGN
        ret
op_usp ENDP
op_movem PROC
        mov     ecx,[oldpc]
        mov     dx,[ecx+2]
        xchg    dl,dh
        mov     eax,[firstword]
        and     al,38h
        cmp     al,20h
        jne     noflop
        mov     eax,edx
        mov     ecx,16
floplp:
        shl     ax,1
        rcr     dx,1
        loop    floplp
noflop:
        mov     word ptr [edi + operand.r1],dx
        mov     eax,NMOVEM
        ret
op_movem endp
op_rel PROC
        movsx   eax,byte ptr [firstword]
        or      eax,eax
        je      op_relw
        cmp     al,0ffh
        jne     relconverge
        or      [edi+operand.mods],EXTBRA
        lodsd
        bswap   eax
        jmp     relconverge
op_relw:
        lodsw
        xchg    al,ah
        movsx   eax,ax
relconverge:
        add     eax,[oldpc]
        sub     eax,[membase]
        inc     eax
        inc     eax
        mov     [edi + operand.bd],eax
        mov     eax,REL
        ret
op_rel ENDP
op_quick  PROC
        movzx   eax, byte ptr [firstword+1]
        shr     al,1
        and     al,7
        jne     noq8
        add     al,8
noq8:
        mov     [edi + operand.bd],eax
        mov     eax,IMM
        ret
op_quick ENDP
op_bcdsrc PROC
        mov     cl,byte ptr [firstword]
        mov     ch,cl
bcdtst:
        and     ch,7
        bt      cx,3
        mov     cl,ch
        jnc     filldn
        jmp     fillanpre
op_bcdsrc ENDP
op_bcddest PROC
        mov     cx,word ptr [firstword]
        shr     ch,1
        jmp     bcdtst
op_bcddest ENDP
op_bf   PROC
        mov     ecx,[oldpc]
        mov     ax,[ecx+2]
        xchg    al,ah
        mov     ecx,eax
        and     eax,3fh
        mov     [edi + operand.r2],al
        shr     ecx,6
        and     ecx,3fh
        mov     [edi + operand.r1],cl
        mov     eax,BF
        ret
op_bf   ENDP

controltab label dword
        dw    8,0,RG_SFC,1,RG_DFC,2,RG_CACR
        dw    800h,RG_USP,801h,RG_VBR,802h,RG_CAAR,803h,RG_MSP,804h,RG_ISP

op_moveccontrol PROC
        mov     ecx,[oldpc]
        movzx   eax,word ptr [ecx+2 ]
        xchg    ah,al
        and     ax,0fffh
        movzx   ecx,word ptr [controltab]
        lea     edx,word ptr [controltab+2]
omclp:
        cmp     [edx],ax
        je      gotctl
        add     edx,4
        loop    omclp
        inc     dbg_badflag
        mov     eax,NONE
        ret
gotctl:
        mov     ax,[edx+2]
        mov     [edi + operand.r1],al
        mov     eax,REGN
        ret
op_moveccontrol ENDP



optable label dword
        dd    op_none, op_ea, op_eaa
        dd    op_eaadnop, op_eaadnor, op_eaadnp
        dd    op_eaadnr, op_eaanor, op_eaanorp
        dd    op_eaanp, op_eaan, op_eadnp
        dd    op_eadnop, op_eanp, op_mea
        dd    0

        dd    op_mpareg, op_areg9b, op_dreg9b
        dd    op_dreg02, op_areg02, op_imm07
        dd    op_imm03, op_imm02, op_immb
        dd    op_immw, op_imm, op_rn04, op_c2a
        dd    op_c2b, op_c2c, op_ereg1
        dd    op_ereg2, op_ern, op_ccr
        dd    op_sr, op_usp
        dd    op_movem, op_rel, op_relw
        dd    op_quick, op_bcdsrc, op_bcddest
        dd    op_bf, op_bfdreg, op_moveccontrol
        dd    op_movecreg

dbg_op_dispatch PROC
        mov     [dbg_badflag],0
        mov     [edi + operand.xtype],NONE
        mov     [edi + operand.mods],0
        mov     [edi + operand.bd],0
        movzx   ecx,al
        mov     ecx,[optable + ecx*4]
        sub     eax,eax
        call    ecx
        mov     [edi + operand.xtype],ax
        mov     al,[dbg_badflag]
        or      al,al
        ret
dbg_op_dispatch ENDP

sz_0 PROC
        mov     ecx,0
szwl:
        mov     eax,SZ_WORD
        bt      word ptr [firstword],cx
        jnc     keep
        inc     eax
keep:
        ret
sz_0 ENDP
sz_34 PROC
        mov     ecx,3
        jmp     szwl
szbwl:
        mov     eax,[firstword] 
        shr     eax,cl
        and     eax,3
        inc     eax
        RET
sz_34 ENDP
sz_6 PROC
        mov     ecx,6
        jmp     szwl
sz_6 ENDP
sz_67 PROC
        mov     ecx,6
        jmp     szbwl
sz_67 ENDP
sz_7 PROC       ; only CHK comes here, sizing is reversed
        mov     eax,SZ_WORD
        bt      word ptr [firstword],7
        jc      keep1
        inc     eax
keep1:
        ret
sz_7 ENDP
sz_8 PROC
        mov     ecx,8
        jmp     szwl
sz_8 ENDP
sz_9a PROC
        mov     ecx,9
        jmp     szbwl
sz_9a ENDP
sz_rel PROC
        mov     eax,SZ_WORD
        mov     cl,byte ptr [firstword]
        or      cl,cl
        je      szrelok
        cmp     cl,0ffh
        jne     szrelbyte
        inc     eax
        ret
szrelbyte:
        dec     eax
szrelok:
        ret
sz_rel  ENDP

sztab LABEL DWORD
        dd    sz_0, sz_34, sz_6
        dd    sz_67, sz_7, sz_8, sz_9a
        dd    sz_rel

dbg_sz_dispatch PROC
        movzx   eax,al
        cmp     al,4
        jc      retval
        mov     eax,[sztab -16 + eax * 4]
        jmp     eax
retval:
        ret
dbg_sz_dispatch ENDP


cd_cmpchk2 PROC
        mov     ecx,[oldpc]
        bt      word ptr [ecx+2],3
        mov     esi,offset mn_cmpz
        jnc     cdcc2got
        mov     esi,offset mn_chkz
cdcc2got:
        mov     edi,offset dbg_buffer
        call    dbg_strapp
        mov     edi,offset dbg_buffer
        mov     esi,offset mn_z2
        call    dbg_strapp
        ret
cd_cmpchk2 ENDP
cd_moves PROC
        mov     ecx,[oldpc]
        bt      word ptr [ecx+2],3 + 8
        jnc     cdmsnoload
        mov     ebx,offset dbg_movsalt
cdmsnoload:
        ret
cd_moves ENDP
cd_mula PROC
        mov     ecx,[oldpc]
        mov     esi,offset mn_zu
        bt      word ptr [ecx+2],3
        jnc     mulagot
        mov     esi,offset mn_zs
mulagot:
        mov     edi,offset dbg_buffer
        call    dbg_strapp
        push    edi
        lea     edi,[dbg_op2]
        mov     ax,[ecx+2]
        xchg    al,ah
        mov     dx,ax
        and     ax,7
        mov     [edi + operand.r1],al
        shr     edx,12
        and     edx,7
        bt      word ptr [ecx+2],2
        jc      mulanolong
        mov     edx,eax    
mulanolong:
        mov     [edi +operand.r2],dl
        mov     [edi +operand.xtype],MDREG
        pop     edi
        ret
cd_mula ENDP
cd_diva PROC
        mov     ecx,[oldpc]
        mov     esi,offset mn_zu
        bt      word ptr [ecx+2],3
        
        jnc     divagot
        mov     esi,offset mn_zs
divagot:
        mov     edi,offset dbg_buffer
        call    dbg_strapp
        push    edi
        mov     edi,offset dbg_op2
        mov     ax,[ecx+2]
        xchg    al,ah
        mov     dx,ax
        and     ax,7
        mov     [edi + operand.r1],al
        shr     dx,12
        and     dx,7
        mov     [edi + operand.r2],dl
        cmp     dl,al
        mov     [edi + operand.xtype],MDREG
        pop     edi
        jz      divanolong
        bt      word ptr [ecx+2],2
        jc      divanolong
        push    ecx
        mov     esi,offset mn_zl
        mov     edi,offset dbg_buffer
        call    dbg_strapp
        pop     ecx
divanolong:
        ret
cd_diva ENDP
condvals label byte
        db    "ra",0
        db    "sr",0
        db    "hi",0
        db    "ls",0
        db    "cc",0
        db    "cs",0
        db    "ne",0
        db    "eq",0
        db    "vc",0
        db    "vs",0
        db    "pl",0
        db    "mi",0
        db    "ge",0
        db    "lt",0
        db    "gt",0
        db    "le",0
at      db      "t",0
        db      "f",0

        align  4
cd_cond PROC
        movzx   eax,byte ptr [firstword + 1]
        cmp     eax,060h
        jnc     condok
        and     al,15
        cmp     al,2
        jnc     condok
        lea     esi,[at + eax * 2]
        jmp     app
condok:
        and     al,15
        lea     esi,[condvals + eax + 2 * eax]
app:
        mov     edi,offset dbg_buffer
        jmp    dbg_strapp
cd_cond ENDP

cdtab label DWORD       
        dd    cd_none, cd_cmpchk2, cd_moves
        dd    cd_mula, cd_diva, cd_cond

dbg_cd_dispatch PROC
        push    esi
        movzx   ecx,al
        mov     ecx,[cdtab + eax*4]
        call    ecx
        pop     esi
cd_none:
        ret
dbg_cd_dispatch ENDP

        end