        .386
        .model flat,stdcall
include win32.ase

        public emuload, emustore, emuinit, emudll, emurundown, emugetparms
        public  emuparms, emureset
        extrn   membase : dword, thesize : byte, memsize : dword, memtop : dword
        extrn   ISRCallBack : PROC

        .data
emudll  db      "simemu.dll",256 DUP(0) 
EmuLoad db      "EmuLoad",0
EmuStore db     "EmuStore",0
EmuParms db     "EmuParms",0
EmuReset db     "EmuReset",0
libhand dd      0
loadproc dd     0
storeproc dd    0
parmsproc dd    0
resetproc dd    0
emuparms  dd    0

        .code
emuinit PROC
        call    LoadLibrary,   offset emudll
        or      eax,eax
        jz      llf
        mov     [libhand],eax
        call    GetProcAddress,eax,offset EmuLoad
        or      eax,eax
        jz      emurundown
        mov     [loadproc],eax
        call    GetProcAddress,[libhand],offset EmuStore
        or      eax,eax
        jz      emurundown
        mov     [storeproc],eax
        call    GetProcAddress,[libhand],offset EmuParms
        or      eax,eax
        jz      emurundown
        mov     [parmsproc],eax
        call    GetProcAddress,[libhand],offset EmuReset
        or      eax,eax
        jz      emurundown
        mov     [resetproc],eax
        ret
llf:
        stc
        ret
        
emuinit ENDP
emurundown PROC
        mov     eax,[libhand]
        or      eax,eax
        jz      nolib
        call    FreeLibrary,eax
        mov     [libhand],0
nolib:
        stc
        ret
emurundown ENDP
emureset PROC
        call    [resetproc]
        ret
emureset ENDP
emugetparms PROC
        call    [parmsproc],[membase], [memtop], offset ISRCallBack
        mov     [emuparms],eax
        ret
emugetparms ENDP
emuload PROC
        push    ecx
        movzx   eax,[thesize]
        call    [loadproc],ecx,eax
        pop     ecx
        ret
emuload ENDP
emustore PROC           
        push    ecx
        movzx   edx,[thesize]
        call    [storeproc],ecx,eax,edx
        pop     ecx
        ret
emustore ENDP

        end